function retstr = LQreg(instruct, outfile)


if (isempty(instruct.citatel_prenosu) |isempty(instruct.menovatel_prenosu))

outstruct.errormsg='Nezadali ste niektory z polynomov prenosu systemu!'; errorcode=1;

elseif (isempty(instruct.fi)| isempty(instruct.psi))
	outstruct.errormsg='Nezadali ste niektory vahovy koeficient!'; errorcode=1;
	
elseif (isempty(instruct.cas_simulacie)| isempty(instruct.cas_ziadanej_hodnoty)| isempty(instruct.velkost_ziadanej_hodnoty)| isempty(instruct.cas_poruchy)| isempty(instruct.velkost_poruchy))
	outstruct.errormsg='Nezadali ste niektory z parametrov simulacie!'; errorcode=1;	

elseif (spolycheck(instruct.citatel_prenosu) | spolycheck(instruct.menovatel_prenosu)),
	outstruct.errormsg='Nespravne zadane polynomy. Pravdepodobne Vam niekde chybaju hranate zatvorky, alebo ste zadali neciselnu hodnotu';
	errorcode=2; 

elseif (spolydeg(instruct.citatel_prenosu) > spolydeg(instruct.menovatel_prenosu)),
	outstruct.errormsg='Polynom citatela nesmie byt vyssieho radu ako polynom menovatela!';
   errorcode=4;

else
	errorcode=0;
end


if errorcode~=0,
	templatefile = which('template.htm');
   	retstr = htmlrep(outstruct, templatefile);
   	return
end

B=mat2pol(str2num(instruct.citatel_prenosu));
A=mat2pol(str2num(instruct.menovatel_prenosu));
Fi=str2num(instruct.fi);
Psi=str2num(instruct.psi);
F=s;

[Df,j]=spf(A'*A);
[Dr,j]=spf(1'*1);
[Dc,j]=spf(Fi*A'*F'*A*F+Psi*B'*B);
[P,Q]=axbyc(A*F,B,Dc*Df);
[W,R]=axbyc(F,B,Dc*Dr);

P1=pol2mat(P);
Q1=pol2mat(Q);
B1=pol2mat(B);
A1=pol2mat(A);
W1=pol2mat(W);
R1=pol2mat(R);


scheme_name='LQregs2';
open_system('LQregs2');


gG=sprintf('%s/G',scheme_name);
gR=sprintf('%s/R',scheme_name);
gR1=sprintf('%s/R1',scheme_name);

AA=sprintf('[%s]',num2str(A1));
BB=sprintf('[%s]',num2str(B1));
set_param(gG,'Denominator',AA);
set_param(gG,'Numerator',BB);

QQ=sprintf('[%s]',num2str(Q1));
PP=sprintf('[%s]',num2str(P1));
set_param(gR,'Denominator',PP);
set_param(gR,'Numerator',QQ);

WW=sprintf('[%s]',num2str(W1));
RR=sprintf('[%s]',num2str(R1));
set_param(gR1,'Denominator',WW);
set_param(gR1,'Numerator',RR);

cas_sim = num2str(instruct.cas_simulacie);
set_param(scheme_name,'Solver','ode45','StopTime',cas_sim);
set_param(scheme_name,'Solver','ode45','Max step size','auto');

cas_ziad = num2str(instruct.cas_ziadanej_hodnoty);
cas_chyba = num2str(instruct.cas_poruchy);
big_ziad = num2str(instruct.velkost_ziadanej_hodnoty);
big_chyba = num2str(instruct.velkost_poruchy);

ziadana=sprintf('%s/ziad',scheme_name);
set_param(ziadana,'Time',cas_ziad);
set_param(ziadana,'Before','0');
set_param(ziadana,'After',big_ziad);

porucha=sprintf('%s/poruch',scheme_name);
set_param(porucha,'Time',cas_chyba);
set_param(porucha,'Before','0');
set_param(porucha,'After',big_chyba);

warning off;
sim(scheme_name);
bdclose('all');

f=figure('visible','off');
plot(simout(:,1),simout(:,2));
xlabel('t [s]'); ylabel('w(t)');
titlestring=sprintf('Vysledok simulacie vypocitaneho regulatora');
title(titlestring);

cd \;
cd www\test;
outstruct.GraphFileName = sprintf('priebeh2.jpeg');
wsprintjpeg(f, outstruct.GraphFileName);
close all;

scheme_name='LQregs1';
open_system('LQregs1');


gG=sprintf('%s/G',scheme_name);
gR=sprintf('%s/R',scheme_name);
gR1=sprintf('%s/R1',scheme_name);

AA=sprintf('[%s]',num2str(A1));
BB=sprintf('[%s]',num2str(B1));
set_param(gG,'Denominator',AA);
set_param(gG,'Numerator',BB);

QQ=sprintf('[%s]',num2str(Q1));
PP=sprintf('[%s]',num2str(P1));
set_param(gR,'Denominator',PP);
set_param(gR,'Numerator',QQ);

cas_sim = num2str((str2num(instruct.cas_simulacie)));
set_param(scheme_name,'Solver','ode45','StopTime',cas_sim);
set_param(scheme_name,'Solver','ode45','Max step size','auto');

cas_ziad = num2str((str2num(instruct.cas_ziadanej_hodnoty)));
cas_chyba = num2str((str2num(instruct.cas_poruchy)));
big_ziad = num2str((str2num(instruct.velkost_ziadanej_hodnoty)));
big_chyba = num2str((str2num(instruct.velkost_poruchy)));

ziadana=sprintf('%s/ziad',scheme_name);
set_param(ziadana,'Time',cas_ziad);
set_param(ziadana,'Before','0');
set_param(ziadana,'After',big_ziad);

porucha=sprintf('%s/poruch',scheme_name);
set_param(porucha,'Time',cas_chyba);
set_param(porucha,'Before','0');
set_param(porucha,'After',big_chyba);

warning off;
sim(scheme_name);
bdclose('all');

f=figure('visible','off');
plot(simout(:,1),simout(:,2));
xlabel('t [s]'); ylabel('w(t)');
titlestring=sprintf('Vysledok simulacie vypocitaneho regulatora');
title(titlestring);

cd \;
cd www\test;
outstruct.GraphFileName = sprintf('priebeh1.jpeg');
wsprintjpeg(f, outstruct.GraphFileName);
close all;
outstruct.cas_simulacie=instruct.cas_simulacie;
outstruct.cas_ziadanej_hodnoty=instruct.cas_ziadanej_hodnoty;
outstruct.velkost_ziadanej_hodnoty=instruct.velkost_ziadanej_hodnoty;
outstruct.cas_poruchy=instruct.cas_poruchy;
outstruct.velkost_poruchy=instruct.velkost_poruchy;
outstruct.citatel_prenosu=pol2html(B1);
outstruct.menovatel_prenosu=pol2html(A1);
outstruct.fi=instruct.fi;
outstruct.psi=instruct.psi;

outstruct.r1_citatel=pol2html(Q1);
outstruct.r1_menovatel=pol2html(P1);
outstruct.r2_citatel=pol2html(W1);
outstruct.r2_menovatel=pol2html(R1);



templatefile = which('sablona.html'); 
if (nargin == 1)
   retstr = htmlrep(outstruct, templatefile);
elseif (nargin == 2)
   retstr = htmlrep(outstruct, templatefile, outfile);
end